<template>
  <div class="content__block">
    <div class="note__controls">
      <router-link to="/">Назад</router-link>
      <span>
        <button @click="toggleEdit">{{ editLabel }}</button>
        <button @click="revertChanges" v-if="reversed || (changed && !edit)">
          {{ changed ? 'Отменить изменения' : 'Вернуть изменения' }}
        </button>
        <button v-else-if="edit" @click="save">Сохранить</button>
        <button @click="clickDelete">Удалить</button>
      </span>
    </div>
    <p v-if="!edit">{{ noteVal.text }}</p>
    <input type="text" v-model="noteVal.text" v-else />
    <hr />

    <div v-for="checkbox in noteVal.checkboxes" :key="checkbox.id">
      <input type="checkbox" v-model="checkbox.done" />
      <label v-if="!edit">{{ checkbox.text }}</label>
      <input type="text" v-model="checkbox.text" v-else />
    </div>
    <button @click="addCheckbox" v-if="edit">+ Чекбокс</button>
  </div>
</template>

<script>
import { mapActions } from 'vuex'

export default {
  data: () => ({
    changed: false,
    reversed: false,
    edit: false,
    tempVal: {},
    noteVal: {},
    initialVal: {},
  }),
  created() {
    this.initialVal = JSON.parse(JSON.stringify(this.note))
    this.noteVal = JSON.parse(JSON.stringify(this.note))
  },
  computed: {
    note() {
      return this.$store.getters.GET_NOTE(Number(this.$route.params.id))
    },
    editLabel() {
      return this.edit ? 'Отменить редактирование' : 'Редактировать'
    },
  },
  methods: {
    ...mapActions(['CREATE_NOTE', 'REMOVE_NOTE', 'UPDATE_NOTE']),
    toggleEdit() {
      if (this.edit) {
        this.$confirm({
          text: 'Отменить изменения?',
          okClick: () => {
            this.edit = !this.edit
          },
        })
      } else {
        this.edit = !this.edit
      }
    },
    save() {
      this['UPDATE_NOTE'](this.noteVal)
      ;(this.changed = true), (this.edit = false)
    },
    revertChanges() {
      if (this.changed) {
        this['UPDATE_NOTE'](this.initialVal)
        this.tempVal = this.noteVal
        this.noteVal = this.initialVal
        this.changed = false
        this.reversed = true
      } else {
        this['UPDATE_NOTE'](this.tempVal)
        this.noteVal = this.tempVal
        this.changed = true
        this.reversed = false
      }
    },
    addCheckbox() {
      const checksList = this.noteVal.checkboxes
      const id = checksList[0] ? checksList[checksList.length - 1].id + 1 : 0
      checksList.push({ done: false, text: '', id })
    },
    clickDelete() {
      this.$confirm({
        okClick: () => {
          this['REMOVE_NOTE'](Number(this.$route.params.id))
          this.$router.push('/')
        },
        text: 'Удалить заметку?',
      })
    },
  },
}
</script>

<style>
.note {
  padding: 12px;
}

.note__controls {
  display: flex;
  justify-content: space-between;
  margin-bottom: 20px;
}
</style>
